/*
 * linux-5.4/drivers/media/platform/sunxi-vin/vin-video/dma_reg_i.h
 *
 * Copyright (c) 2007-2017 Allwinnertech Co., Ltd.
 *
 * Authors:  Zhao Wei <zhaowei@allwinnertech.com>
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef __CSIC__DMA__REG__I__H__
#define __CSIC__DMA__REG__I__H__

/*
 * Detail information of registers
 */
#define	CSIC_DMA_EN_REG_OFF			0X000
#define	CSIC_DMA_TOP_EN				0
#define CSIC_DMA_TOP_EN_MASK			(0X1 << CSIC_DMA_TOP_EN)
#define	CSIC_CLK_CNT_EN				1
#define	CSIC_CLK_CNT_EN_MASK			(0X1 << CSIC_CLK_CNT_EN)
#define	CSIC_CLK_CNT_SPL			2
#define	CSIC_CLK_CNT_SPL_MASK			(0X1 << CSIC_CLK_CNT_SPL)
#define	CSIC_FBC_EN				3
#define	CSIC_FBC_EN_MASK			(0X1 << CSIC_FBC_EN)
#define	CSIC_DMA_EN				4
#define	CSIC_DMA_EN_MASK			(0X1 << CSIC_DMA_EN)
#define	CSIC_FRAME_CNT_EN			5
#define	CSIC_FRAME_CNT_EN_MASK			(0X1 << CSIC_FRAME_CNT_EN)
#define	CSIC_BUF_ADDR_MODE			7
#define	CSIC_BUF_ADDR_MODE_MASK  		(0X1 << CSIC_BUF_ADDR_MODE)
#define	CSIC_LBC_EN				8
#define	CSIC_LBC_EN_MASK			(0X1 << CSIC_LBC_EN)
#define	CSIC_FLIP_SIZE_CFG_MODE 		28
#define	CSIC_FLIP_SIZE_CFG_MODE_MASK    	(0X1 << CSIC_FLIP_SIZE_CFG_MODE)
#define	CSIC_BUF_LENGTH_CFG_MODE		29
#define	CSIC_BUF_LENGTH_CFG_MODE_MASK   	(0X1 << CSIC_BUF_LENGTH_CFG_MODE)
#define	CSIC_VFLIP_BUF_ADDR_CFG_MODE    	30
#define	CSIC_VFLIP_BUF_ADDR_CFG_MODE_MASK	(0X1 << CSIC_VFLIP_BUF_ADDR_CFG_MODE)

#define	CSIC_DMA_CFG_REG_OFF			0X004
#define	MIN_SDR_WR_SIZE				0
#define	MIN_SDR_WR_SIZE_MASK			(0X3 << MIN_SDR_WR_SIZE)
#define	FPS_DS					6
#define	FPS_DS_MASK				(0XFF << FPS_DS)
#define	FIELD_SEL				10
#define	FIELD_SEL_MASK				(0X3 << FIELD_SEL)
#define	HFLIP_EN				12
#define	HFLIP_EN_MASK				(0X1 << HFLIP_EN)
#define	VFLIP_EN				13
#define	VFLIP_EN_MASK				(0X1 << VFLIP_EN)
#define	OUTPUT_FMT				16
#define	OUTPUT_FMT_MASK				(0XF << OUTPUT_FMT)
#define	ENABLE_10BIT_CUT2_8BIT  		21
#define	ENABLE_10BIT_CUT2_8BIT_MASK		(0X1 << ENABLE_10BIT_CUT2_8BIT)
#define	PAD_VAL					24
#define	PAD_VAL_MASK				(0XFF << PAD_VAL)

#define	CSIC_DMA_HSIZE_REG_OFF			0X010
#define	HOR_START				0
#define	HOR_START_MASK				(0X3FFF << HOR_START)
#define	HOR_LEN					16
#define	HOR_LEN_MASK				(0X3FFF << HOR_LEN)

#define	CSIC_DMA_VSIZE_REG_OFF			0X014
#define	VER_START				0
#define	VER_START_MASK				(0X3FFF << VER_START)
#define	VER_LEN					16
#define	VER_LEN_MASK				(0X3FFF << VER_LEN)

#define	CSIC_DMA_F0_BUFA_REG_OFF		0X020
#define	F0_BUFA					0
#define	F0_BUFA_MASK				(0XFFFFFFFF << F0_BUFA)

#define	CSIC_DMA_F1_BUFA_REG_OFF		0X028
#define	F1_BUFA					0
#define	F1_BUFA_MASK				(0XFFFFFFFF << F1_BUFA)

#define	CSIC_DMA_F2_BUFA_REG_OFF		0X030
#define	F2_BUFA					0
#define	F2_BUFA_MASK				(0XFFFFFFFF << F2_BUFA)

#define	CSIC_DMA_BUF_LEN_REG_OFF		0X038
#define	BUF_LEN					0
#define	BUF_LEN_MASK				(0X3FFF << BUF_LEN)
#define	BUF_LEN_C				16
#define	BUF_LEN_C_MASK				(0X3FFF << BUF_LEN_C)

#define	CSIC_DMA_FLIP_SIZE_REG_OFF		0X03C
#define	VALID_LEN				0
#define	VALID_LEN_MASK				(0X3FFF << VALID_LEN)
#define	VER_LEN					16
#define	VER_LEN_MASK				(0X3FFF << VER_LEN)

#define	CSIC_DMA_CAP_STA_REG_OFF		0X04C
#define	SCAP_STA				0
#define	SCAP_STA_MASK				(0X1 << SCAP_STA)
#define	VCAP_STA				1
#define	VCAP_STA_MASK				(0X1 << VCAP_STA)
#define	FIELD_STA				2
#define	FIELD_STA_MASK				(0X1 << FIELD_STA)

#define	CSIC_DMA_INT_EN_REG_OFF			0X050
#define	CD_INT_EN				0
#define	CD_INT_EN_MASK				(0X1 << CD_INT_EN)
#define	FD_INT_EN				1
#define	FD_INT_EN_MASK				(0X1 << FD_INT_EN)
#define	FIFO0_OF_INT_EN				2
#define	FIFO0_OF_INT_EN_MASK			(0X1 << FIFO0_OF_INT_EN)
#define	FIFO1_OF_INT_EN				3
#define	FIFO1_OF_INT_EN_MASK			(0X1 << FIFO1_OF_INT_EN)
#define	FIFO2_OF_INT_EN				4
#define	FIFO2_OF_INT_EN_MASK			(0X1 << FIFO2_OF_INT_EN)
#define	LC_INT_EN				5
#define	LC_INT_EN_MASK				(0X1 << LC_INT_EN)
#define	HB_OF_INT_EN				6
#define	HB_OF_INT_EN_MASK			(0X1 << HB_OF_INT_EN)
#define	VS_INT_EN				7
#define	VS_INT_EN_MASK				(0X1 << VS_INT_EN)
#define	FBC_OVHD_WRDDR_FULL_INT_EN		8
#define	FBC_OVHD_WRDDR_FULL_INT_EN_MASK		(0X1 << FBC_OVHD_WRDDR_FULL_INT_EN)
#define	FBC_DATA_WRDDR_FULL_INT_EN		9
#define	FBC_DATA_WRDDR_FULL_INT_EN_MASK		(0X1 << FBC_DATA_WRDDR_FULL_INT_EN)
#define	BUF_ADDR_FIFO_INT_EN			13
#define	BUF_ADDR_FIFO_INT_EN_MASK  		(0X1 << BUF_ADDR_FIFO_INT_EN)
#define	STORED_FRM_CNT_INT_EN   		14
#define	STORED_FRM_CNT_INT_EN_MASK		(0X1 << STORED_FRM_CNT_INT_EN)
#define	FRM_LOST_INT_EN 			15
#define	FRM_LOST_INT_EN_MASK			(0X1 << FRM_LOST_INT_EN)

#define	CSIC_DMA_INT_STA_REG_OFF		0X054
#define	CD_PD					0
#define	CD_PD_MASK				(0X1 << CD_PD)
#define	FD_PD					1
#define	FD_PD_MASK				(0X1 << FD_PD)
#define	FIFO0_OF_PD				2
#define	FIFO0_OF_PD_MASK			(0X1 << FIFO0_OF_PD)
#define	FIFO1_OF_PD				3
#define	FIFO1_OF_PD_MASK			(0X1 << FIFO1_OF_PD)
#define	FIFO2_OF_PD				4
#define	FIFO2_OF_PD_MASK			(0X1 << FIFO2_OF_PD)
#define	LC_PD					5
#define	LC_PD_MASK				(0X1 << LC_PD)
#define	HB_OF_PD				6
#define	HB_OF_PD_MASK				(0X1 << HB_OF_PD)
#define	VS_PD					7
#define	VS_PD_MASK				(0X1 << VS_PD)
#define	BUF_ADDR_FIFO_INT_PD			13
#define	BUF_ADDR_FIFO_INT_PD_MASK  		(0X1 << BUF_ADDR_FIFO_INT_PD)
#define	STORED_FRM_CNT_INT_PD   		14
#define	STORED_FRM_CNT_INT_PD_MASK		(0X1 << STORED_FRM_CNT_INT_PD)
#define	FRM_LOST_INT_PD 			15
#define	FRM_LOST_INT_PD_MASK			(0X1 << FRM_LOST_INT_PD)
#define	LBC_HB_INT_PD				16
#define	LBC_HB_INT_PD_MASK			(0X1 << LBC_HB_INT_PD)

#define	CSIC_DMA_LINE_CNT_REG_OFF		0X058
#define	LINE_CNT_NUM				0
#define	LINE_CNT_NUM_MASK			(0X1FFF << LINE_CNT_NUM)

#define CSIC_DMA_FRM_CNT_REG_OFF		0X05C
#define CSIC_DMA_CLR_DIS			16
#define CSIC_DMA_CLR_DIS_MASK			(0X7FFF << CSIC_DMA_CLR_DIS)
#define CSIC_DMA_FRM_CNT			0
#define CSIC_DMA_FRM_CNT_MASK			(0XFFFF << CSIC_DMA_FRM_CNT)

#define	CSIC_DMA_FRM_CLK_CNT_REG_OFF		0X060
#define	FRM_CLK_CNT				0
#define	FRM_CLK_CNT_MASK			(0XFFFFFF << FRM_CLK_CNT)

#define	CSIC_DMA_ACC_ITNL_CLK_CNT_REG_OFF	0X064
#define	ITNL_CLK_CNT				0
#define	ITNL_CLK_CNT_MASK			(0XFFFFFF << ITNL_CLK_CNT)
#define	ACC_CLK_CNT				24
#define	ACC_CLK_CNT_MASK			(0XFF << ACC_CLK_CNT)

#define	CSIC_DMA_FIFO_STAT_REG_OFF		0X068
#define	FIFO_FRM_MAX				0
#define	FIFO_FRM_MAX_MASK			(0XFFF << FIFO_FRM_MAX)

#define	CSIC_DMA_FIFO_THRS_REG_OFF		0X06C
#define	FIFO_THRS				0
#define	FIFO_THRS_MASK				(0XFFF << FIFO_THRS)
#define	FIFO_NEARLY_FULL_TH			13
#define	FIFO_NEARLY_FULL_TH_MASK		(0XFF << FIFO_NEARLY_FULL_TH)

#define	CSIC_DMA_PCLK_STAT_REG_OFF		0X070
#define	PCLK_CNT_LINE_MIN			0
#define	PCLK_CNT_LINE_MIN_MASK			(0XFFF << PCLK_CNT_LINE_MIN)
#define	PCLK_CNT_LINE_MAX			16
#define	PCLK_CNT_LINE_MAX_MASK			(0XFF << PCLK_CNT_LINE_MAX)

#define	CSIC_DMA_BUFA_F0_ENTRY_REG_OFF  	0X080
#define	BUFA_F0_ENTRY				0
#define	BUFA_F0_ENTRY_MASK			(0XFFFFFFFF << BUFA_F0_ENTRY)

#define	CSIC_DMA_BUFA_F1_ENTRY_REG_OFF  	0X084
#define	BUFA_F1_ENTRY				0
#define	BUFA_F1_ENTRY_MASK			(0XFFFFFFFF << BUFA_F1_ENTRY)

#define	CSIC_DMA_BUFA_F2_ENTRY_REG_OFF  	0X088
#define	BUFA_F1_ENTRY				0
#define	BUFA_F1_ENTRY_MASK			(0XFFFFFFFF << BUFA_F1_ENTRY)

#define	CSIC_DMA_BUF_THRESHOLD_REG_OFF  	0X08c
#define	DMA_BUFA_FIFO_THRESHOLD 		0
#define	DMA_BUFA_FIFO_THRESHOLD_MASK    	(0x3F << DMA_BUFA_FIFO_THRESHOLD)
#define	DMA_STORED_FRM_THRESHOLD		16
#define	DMA_STORED_FRM_THRESHOLD_MASK   	(0x3F << DMA_STORED_FRM_THRESHOLD)

#define	CSIC_DMA_STORED_FRM_CNT_REG_OFF  	0X094
#define	DMA_STORED_FRM_CNT			0
#define	DMA_STORED_FRM_CNT_MASK 		(0xFF << DMA_STORED_FRM_CNT)

#define	CSIC_LBC_CONFIGURE_REG_OFF		0X100
#define	LIMIT_QP_MIM				0
#define	LIMIT_QP_MIM_MASK  			(0X7 << LIMIT_QP_MIM)
#define	LIMIT_QP_ENABLE 			3
#define	LIMIT_QP_ENABLE_MASK 			(0X1 << LIMIT_QP_ENABLE)
#define	UPDATE_ADVANTURE_RATIO  		16
#define	UPDATE_ADVANTURE_RATIO_MASK     	(0X1F << UPDATE_ADVANTURE_RATIO)
#define	UPDATE_ADVANTURE_ENABLE 		21
#define	UPDATE_ADVANTURE_ENABLE_MASK    	(0X1 << UPDATE_ADVANTURE_ENABLE)
#define	MSQ_ENABLE				24
#define	MSQ_ENABLE_MASK  			(0X1 << MSQ_ENABLE)
#define	OTS_ENABLE				25
#define	OTS_ENABLE_MASK  			(0X1 << OTS_ENABLE)
#define	DTS_ENABLE				26
#define	DTS_ENABLE_MASK  			(0X1 << DTS_ENABLE)
#define	GLB_ENABLE				27
#define	GLB_ENABLE_MASK  			(0X1 << GLB_ENABLE)
#define	WHETHER_LOSSY_ENABLE			31
#define	WHETHER_LOSSY_ENABLE_MASK 		(0X1 << WHETHER_LOSSY_ENABLE)

#define	CSIC_LBC_LINE_TARGET_BIT0_REG_OFF	0X104
#define	CMP_TRG_BIT_FOR_EVEN_LINE		0
#define	CMP_TRG_BIT_FOR_EVEN_LINE_MASK   	(0XFFFFF << CMP_TRG_BIT_FOR_EVEN_LINE)

#define	CSIC_LBC_LINE_TARGET_BIT1_REG_OFF	0X108
#define	CMP_TRG_BIT_FOR_ODD_LINE		0
#define	CMP_TRG_BIT_FOR_ODD_LINE_MASK   	(0XFFFFF << CMP_TRG_BIT_FOR_ODD_LINE)

#define	CSIC_LBC_RC_ADV_REG_OFF  		0X10C
#define	RATE_CONTROL_ADVANTURE_0		0
#define	RATE_CONTROL_ADVANTURE_0_MASK   	(0XFF << RATE_CONTROL_ADVANTURE_0)
#define	RATE_CONTROL_ADVANTURE_1		8
#define	RATE_CONTROL_ADVANTURE_1_MASK   	(0XFF << RATE_CONTROL_ADVANTURE_1)
#define	RATE_CONTROL_ADVANTURE_2		16
#define	RATE_CONTROL_ADVANTURE_2_MASK   	(0XFF << RATE_CONTROL_ADVANTURE_2)
#define	RATE_CONTROL_ADVANTURE_3		24
#define	RATE_CONTROL_ADVANTURE_3_MASK   	(0XFF << RATE_CONTROL_ADVANTURE_3)

#define	CSIC_LBC_MB_MIN_REG_OFF  		0X110
#define	MACROBLOCK_MIN_BITS0			0
#define	MACROBLOCK_MIN_BITS0_MASK  		(0XFF << MACROBLOCK_MIN_BITS0)
#define	MACROBLOCK_MIN_BITS1			16
#define	MACROBLOCK_MIN_BITS1_MASK  		(0XFF << MACROBLOCK_MIN_BITS1)

#endif /*__CSIC__DMA__REG__I__H__*/
